<template>
  <div id="app">
    <div class="container pt-3">
      <div class="row">
        <div class="col-12 app-header text-center p-3">
         <span class="logo mr-2 text-danger">R-MIX</span>
        </div>
        <div class="col-12 app-search">
          <Search :posts="posts" />
        </div>
        <div class="col-12 app-subreddits">
          <SubredditList :subreddits="subreddits" />
        </div>
        <div class="col-12 app-listing">
          <div class="loading-container" :class="{active: loading}"><div class="lds-ripple"><div></div><div></div></div></div>
          <Listing :posts="posts" :subreddits="subreddits" />
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import {getSubredditData} from "../utils/helpers"
import Listing from "./Listing";
import Search from "./Search";
import SubredditList from "./SubredditList";
import { eventBus } from "../main";

export default {
  name: "App",
  components: {
    SubredditList,
    Listing,
    Search
  },
  data() {
    return {
      title: "Hello",
      posts: [],
      subreddits: [],
      defaultSubreddit:'funny',
      after: "",
      limit: 10,
      sort: 'hot',
      timeframe: '',
      loading: false
    };
  },
  methods: {
    getRedditData(after) {
      if (this.subreddits.length === 0) {
        return;
      }
      //reset if not load infinite load
      if(!after){
        this.posts = [];
        this.after = "";
      }
   
      this.loading = true;
      // fetch data from the api
        getSubredditData(this.subreddits, this.limit, this.after, this.sort, this.timeframe)
        .then( json => {
          json.data.children.forEach(post => {
            this.posts.push(post);
          });
          this.after = json.data.after;
          this.loading = false;
        })
    },
    loadNextPosts() {
      this.getRedditData(this.after);
    },
    addNewSubreddit(payload) {
      if (this.subreddits.indexOf(payload.subreddit) === -1) {
        this.subreddits.push(payload.subreddit);
        this.saveSubredditsToStorage();
        this.saveSubredditsToUrl();
      }
    },
    deleteSubreddit(payload) {
      const subredditToDelete = payload.subreddit;
      this.subreddits = this.subreddits.filter(s => s !== subredditToDelete);
      this.saveSubredditsToStorage();
      if(this.subreddits.length > 0){
        this.saveSubredditsToUrl();
      }
      else{
        this.$router.replace('/').catch(e => {});
        this.posts = [];
        this.after = "";
      }  
    },
    saveSubredditsToStorage() {
      localStorage.setItem("subreddits", this.subreddits.toString());
    },
    saveSubredditsToUrl() {
      if (this.subreddits.length > 0){
       this.$router.push({query: { s: this.subreddits.toString() }}).catch(e =>{});
       window.gtag('config', 'UA-159041404-1', {
          'page_title' : 'R-MIX - Scroll to view reddit images and videos. No bullshit.',
          'page_path': this.subreddits.toString()
        });
      }
      else{
         this.$router.replace('/')
      }
  
    },
    readSubredditsFromStorage() {
      let data = localStorage.getItem("subreddits");
      if (data !== null && data !== '') {
        return data.split(",");
      } else {
        return null;
      }
    },
    readSubredditsFromURL(){
      if(location.search.length > 0){
        let subreddits = location.search.split('=');
        return subreddits[1].split(',');
      }
      else{
        return null;
      }
    },
    checkScrollerOffset() {
      let scrollerDistanceToTop = document
        .getElementById("posts-end")
        .getBoundingClientRect().top;
      if (window.pageYOffset > scrollerDistanceToTop) {
        return true;
      } else {
        return false;
      }
    }
  },
  watch: {
    subreddits: function() {
      this.getRedditData();
    },
    sort: function(){
      this.getRedditData();
    },
    timeframe: function(){
      this.getRedditData();
    }



  },
  created() {
    eventBus.$on("addSubreddit", payload => {
      this.addNewSubreddit(payload);
    });
    eventBus.$on("deleteSubreddit", payload => {
      this.deleteSubreddit(payload);
    });
    eventBus.$on("loadMore", () => {
      this.loadNextPosts();
    });
    eventBus.$on("sortChange", payload => {
      this.sort = payload.newVal
    });
    eventBus.$on("timeFrameChange", payload => {
      this.timeframe = payload.newVal
    });
  },
  mounted() {
    // handle auto loading more posts
    const options = {
      threshold: 0.1
    };
    const observer = new IntersectionObserver(entries => {
      if (entries[0].intersectionRatio) {

        if(this.posts.length >= this.limit){
          this.loadNextPosts();
        }
      }
    }, options);
    const footer = document.getElementById("posts-end");
    observer.observe(footer);

    // check if we have saved subreddits
    //1 from storage
    const storageSubreddits = this.readSubredditsFromStorage();
    const urlSubreddits = this.readSubredditsFromURL();
   
      if( urlSubreddits !== null){
        this.subreddits = urlSubreddits;
      }
     else if (storageSubreddits !== null) {
      this.subreddits = storageSubreddits;
    }
    else{
      this.addNewSubreddit({ subreddit: this.defaultSubreddit });
    }
  }
 
};
</script>

<style lang="scss">
@import "../styles/components/app";
</style>
